
include(xProject)

list(APPEND _CMAKE_ARGS "-DCMAKE_INSTALL_PREFIX=")
if(BUILD_SHARED_LIBS OR NOT DEFINED BUILD_SHARED_LIBS)
    list(APPEND _CMAKE_ARGS "-DBUILD_SHARED_LIBS=ON")
    set(LOGGER_LIBRARY "liblogger.so")
else()
    list(APPEND _CMAKE_ARGS "-DBUILD_SHARED_LIBS=OFF")
    set(LOGGER_LIBRARY "liblogger.a")
endif()
if(CMAKE_INSTALL_LIBDIR)
  list(APPEND _CMAKE_ARGS "-DCMAKE_INSTALL_LIBDIR=${CMAKE_INSTALL_LIBDIR}")
endif()

xProject_Add(LOGGER
    GIT_SUBMODULE
    CMAKE_ARGS ${_CMAKE_ARGS}
    CMAKE_CACHE_ARGS "-DEXT_CACHE:path=${CMAKE_BINARY_DIR}"
    INSTALL_COMMAND $(MAKE) install "DESTDIR=${CMAKE_BINARY_DIR}/instroot"
    LIBRARIES "${CMAKE_BINARY_DIR}/instroot/${CMAKE_INSTALL_LIBDIR}/${LOGGER_LIBRARY}"
    INCLUDE_DIRS "${CMAKE_BINARY_DIR}/instroot/${CMAKE_INSTALL_INCLUDEDIR}")
xProject_Install(LOGGER)

unset(_CMAKE_ARGS)

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(Logger
    REQUIRED_VARS LOGGER_LIBRARIES LOGGER_INCLUDE_DIRS)

add_library(logger::logger UNKNOWN IMPORTED)
file(MAKE_DIRECTORY "${LOGGER_INCLUDE_DIRS}")
set_target_properties(logger::logger PROPERTIES
    INTERFACE_INCLUDE_DIRECTORIES "${LOGGER_INCLUDE_DIRS}"
    IMPORTED_LINK_INTERFACE_LANGUAGES "CXX"
    IMPORTED_LOCATION "${LOGGER_LIBRARIES}")
# Mainly for static linking
target_link_libraries(logger::logger INTERFACE pthread)
add_dependencies(logger::logger LOGGER)
